<template>
    <div
      class="q-ml-sm"
      :style="{marginRight: '-1px'}"
    >
      <q-item>
        <q-item-side left>
          <q-btn
            v-if="item"
            round
            class="q-mr-sm"
            :class="`menu-item__drag-handle${item.parent_id || ''}`"
            icon="drag_handle"
            size="xs"
          />
        </q-item-side>
        <q-item-main
          :label="item.menu_name"
          :sublabel="`${item.collection_id || `<i class=text-grey>No selected collection</i>`}`"
        />
        <q-item-side right>
          <q-btn
            icon="build"
            size="sm"
            color="blue"
            round
            @click="edit(index)"
          />
          <q-btn
            icon="delete"
            size="sm"
            color="red"
            round
            @click="remove(index)"
            class="q-ml-sm"
          />
          <q-btn
            icon="add"
            size="sm"
            color="green"
            round
            @click="add(index)"
            class="q-ml-sm"
          />
        </q-item-side>
      </q-item>
      <draggable
        v-if="order[item.id]"
        v-model="order[item.id]"
        :handle="`.menu-item__drag-handle${item.id}`"
        class="q-list"
        @change="info => changeOrder(item.id, info)"
      >
        <menu-item
          v-for="subItem in order[item.id]"
          :key="subItem"
          :index="subItem"
          :items="items"
          :edit="edit"
          :add="add"
          :remove="remove"
          :order="order"
          :change-order="changeOrder"
        />
      </draggable>
    </div>
</template>

<script>
  export default {
    name: 'menuItem',
    computed: {
      item() {
        return this.items[this.index];
      },
      children() {
        return [...this.order[this.item.id]];
      },
    },
    props: {
      index: Number,
      items: Array,
      edit: Function,
      remove: Function,
      add: Function,
      order: Object,
      parent: Number,
      changeOrder: Function,
    },
  };
</script>
